#ifndef ELEMENT_H
#define ELEMENT_H

#include "vec2f.h"

struct Element{
   float Kdata[36];
   float damping_ratio;

   Element(void)
   {
      for(int i=0; i<36; ++i)
	 Kdata[i]=0;
   }

   void compute(float youngs_modulus, float poisson_ratio, const Vec2f &restx1, const Vec2f &restx2, const Vec2f &restx3); 
   void apply_elastic(const Vec2f &d1, const Vec2f &d2, const Vec2f &d3, Vec2f &f1, Vec2f &f2, Vec2f &f3) const;
   void apply_damping(const Vec2f &v1, const Vec2f &v2, const Vec2f &v3, Vec2f &f1, Vec2f &f2, Vec2f &f3) const;

   float &K (int i, int j)
   { return Kdata[i+6*j]; }

   const float &K (int i, int j) const
   { return Kdata[i+6*j]; }
};

void polar_rotation(const Vec2f &restx1, const Vec2f &restx2, const Vec2f &restx3,
                    const Vec2f &x1, const Vec2f &x2, const Vec2f &x3, float &cosine, float &sine);

#endif
