#ifndef EXTERNALFORCES_H
#define EXTERNALFORCES_H

#include <vector>
#include "vec2f.h"

struct ExternalForces{
   Vec2f gravity;
  
   // springs
   std::vector<int> attachment_node;
   std::vector<Vec2f> attachment_point;
   float stiffness, damping;

   ExternalForces(void)
      : gravity(0, -9.8)
   {}

   void add_forces(const std::vector<float> &mass, const std::vector<Vec2f> &x, const std::vector<Vec2f> &v, std::vector<Vec2f> &f)
   {
      unsigned int i;
      for(i=0; i<mass.size(); ++i)
	 f[i]+=mass[i]*gravity;
      for(i=0; i<attachment_node.size(); ++i){
	 int j=attachment_node[i];
	 Vec2f dx=x[j]-attachment_point[i];
	 f[j]-=(stiffness+damping*dot(dx,v[j])/mag2(dx))*dx;
      }
   }
};

#endif
